
Global loop,value, Sqr , SqrColor , mx, my, Square ,  Column, Row, Score, Marker, Number1, Number2, Enter,Zone
Global Checksum, GameOver, Sound1, Sound2, Moves , Time, Count
Global leftarrow
Global rightarrow

Dim Board(80)
Dim Board2(80)
Dim Piece(10)
Dim GameSet( 30,9 )
Dim Hits(10)
SeedRnd MilliSecs() 

Graphics 1200,700,24,2
SetBuffer BackBuffer()
Cls
Color 0,0,0
MakePieces()
value = 1
loop = 1
Score = 0
Setup()
; Main Loop

While loop = 1
  Delay 40
  Cls 
  BuildBoard()
  MakeSquares()
  
  DisplayPieces()
  DisplayText()
  
 
  If GameOver = 0 Then CheckMouse()
 
  SetScore()
  DrawPiece(50,50)
  EndGame()
   

  value=GetKey()
 
   If value = 32 Then 
     loop=0                 ; break out of loop
   End If

  VWait
  Flip

Wend
 FreeImage rightarrow
 FreeImage leftarrow
 FreeSound Sound1
 FreeSound Sound2
End

Function BuildBoard()

  Color 0,0,255
  Rect 250,10,834,674,0
  Rect 252,12,830,670,0
  Color 40,0,50
  Rect 254,14,826,666,1

  Color 0,0,255
  Rect 262,22,810,650,0

  Color 255,10,10
  Rect 264,24,806,646,0

  Color 255,255,255
  Rect 266,26,802,642,0


End Function

Function MakeSquares()
 Local x,y,a,b,size
 x = 267 : y=107 : size = 80
 For a = 1 To 10

     For b = 1 To 3
          Rect x,y,size,size,0
          y=y+size
     Next 
     x=x+size
     y=107
 Next


End Function

Function MakePieces()
 Local a,b,c,cnt
  c=1
  cnt = 1
  Sqr = CreateImage(82,82,10)
 

  For a = 1 To 9
     SetColor(a)
 
     SetBuffer ImageBuffer(Sqr,a)
     Rect 10,10,80,80,1
 
  Next

  For a = 1 To 9
     SetBuffer ImageBuffer(Sqr,a)

     Color 255,255,255
     Rect 12,12,68,68,0
     Rect 14,14,64,64,0
     Rect 16,16,60,60,0
     Rect 18,18,56,56,0
     
  
  Next
    Cambria = LoadFont("Cambria",72,False,False,False)
    Cambria2 = LoadFont("Cambria",16,False,False,False)

    SetFont Cambria
    b = 1
  For a = 1 To 9
      SetBuffer ImageBuffer(Sqr,a)
      Color 0,0,0
      Text 28,8, Chr$( a+48 )
       
  Next
  Color 100,150,230
  


  Color 0,0,10
  Marker = CreateImage(82,82,10)
     SetBuffer ImageBuffer(Marker)
     Rect 5,5,78,78,0
     Rect 7,7,74,74,0
     Rect 9,9,70,70,0
     Rect 11,11,66,66,0
     Rect 13,13,62,62,0
     Rect 15,15,58,58,0
     Rect 17,17,54,54,0
  
  SetBuffer ImageBuffer(Sqr,0)
   Rect 10,10,80,80,1
 
  SetBuffer BackBuffer()
  FreeFont Cambria
  FreeFont Cambria2


End Function

Function DrawPiece(x,y)
 
   DrawImage Marker,x+1,y+1

End Function



Function SetColor( a )
     If a = 1 Then   Color 60,255,50
     If a = 2 Then   Color 20,20,255
     If a = 3 Then   Color 250,50,50
     If a = 4 Then   Color 50,250,250
     If a = 5 Then   Color 250,50,250
     If a = 6 Then   Color 250,250,50
     If a = 7 Then   Color 150,20,180
     If a = 8 Then   Color 20,130,130
     SqrColor = a
     
End Function


Function DisplayPieces()
   Local x,y,a,b,c
   x= 261 : y=101
   For a = 1 To 30
        b= Board(a)
       
        If b > 0  Then 
           DrawImage Sqr,x,y,b
        End If
      
 
        x= x + 80
        If x> 1060 Then 
           x = 261
           y = y + 80
        End If 
   Next
   DrawImage leftarrow,180,120
   DrawImage leftarrow,180,200
   DrawImage leftarrow,180,280
   DrawImage rightarrow,1120,120
   DrawImage rightarrow,1120,200
   DrawImage rightarrow,1120,280 
End Function

Function DisplayText()

 If GameOver = 0 Then 
 
  Text 400,400,"   To play the game, click on one of the arrows to move "
  Text 400,415," a row of numbers"
  Text 400,430,"   Line up three numbers whose sum is equal to the number"
  Text 400,445," at upper left part of the board. The computer will remove "
  Text 400,460," the three numbers and give you points."
  Text 400,475," The game is over when you run out of moves."
  Text 400,490," "
  Text 400,505,""
  Text 400,535," http://rb23.yolasite.com " 

 End If 

 If GameOver = 1 Then 
 
  Text 400,505," "
  Text 400,600," http://rb23.yolasite.com " 

 End If 

 
    Color 255,180,255

    Cambria2 = LoadFont("Cambria",72,False,False,False)
    SetFont Cambria2
    
    Text 300,30,Str$ Number1
    Text 500,30, " MOVES LEFT: "
    Text 900,30,Str$ Moves
    Color 255,255,200

    If GameOver = 1 Then 
       Text 10,400, " GAME "
       Text 10,500, " OVER "

    End If 

    FreeFont Cambria2

End Function


Function Setup()
  Local a,b,r
  b=1
  For a = 1 To 40
     r = Rand (2,9)
     Board(a) = r
     b=b+1
     If b>10 b=1
  Next
   rightarrow = LoadImage ( "data\rightarrow.bmp")
   leftarrow = LoadImage ( "data\leftarrow.bmp")
  Sound2 = LoadSound( "data\beep6.wav")
  Sound1 = LoadSound( "data\click.wav")
 
  Number1 = Rand(5,20)
  GameOver = 0
 
  Moves= 15
  Time = 0
  Count = 0

End Function

Function CheckMouse()
 Local a,b,c,x,y,x2,y2
 a = GetMouse() 
 If a > 0 Then 
     mx=MouseX() 
     my=MouseY()
     Square = 0
       x=28 : x2 = 108 : y = 27 : y2 = 107 
     For b = 1 To 20
         If mx > x And mx < x2 Then Column = b
         x = x + 80
         x2 = x2 + 80
     Next 
     For c = 1 To 20
         If my > y And my < y2 Then Row = c
         y = y + 80
         y2 = y2 + 80
     Next      
     If Column > 0 Then 
        Zone = Row * 15 - 15 + Column
      
     End If
     If MouseDown(1) Then 
        SelectZone()
        AddColumns()
        Time = 0
           Moves = Moves - 1
     End If 
 End If 
  
End Function

Function SelectZone()
   Local a 
      If Zone = 18 Then 
        a= Board(1) : Board(1) = Board(2) : Board(2) = Board(3) : Board(3) = Board(4) : Board(4) = Board(5) : Board(5) = Board(6) 
        Board(6) = Board(7) :Board(7) = Board(8) :Board(8) = Board(9) :Board(9) = Board(10) : Board(10) = a 
      End If 
      If Zone = 33 Then 
        a= Board(11) :Board(11) = Board(12) :Board(12) = Board(13) :Board(13) = Board(14) :Board(14) = Board(15) :Board(15) = Board(16) 
        Board(16) = Board(17) :Board(17) = Board(18) :Board(18) = Board(19) :Board(19) = Board(20) : Board(20) = a 

      End If 
      If Zone = 48 Then 
        a= Board(21) :Board(21) = Board(22) :Board(22) = Board(23) :Board(23) = Board(24) :Board(24) = Board(25) :Board(25) = Board(26) 
        Board(26) = Board(27) :Board(27) = Board(28) :Board(28) = Board(29) :Board(29) = Board(30) : Board(30) = a 

      End If 
      If Zone = 29 Then
        a= Board(10) :Board(10) = Board(9) :Board(9) = Board(8) :Board(8) = Board(7) :Board(7) = Board(6) :Board(6) = Board(5) 
        Board(5) = Board(4) :Board(4) = Board(3) :Board(3) = Board(2) :Board(2) = Board(1) : Board(1) = a 

      End If  
      If Zone = 44 Then
        a= Board(20) :Board(20) = Board(19) :Board(19) = Board(18) :Board(18) = Board(17) :Board(17) = Board(16) :Board(16) = Board(15) 
        Board(15) = Board(14) :Board(14) = Board(13) :Board(13) = Board(12) :Board(12) = Board(11) : Board(11) = a 
      End If 
      If Zone = 59 Then 
        a= Board(30) :Board(30) = Board(29) :Board(29) = Board(28) :Board(28) = Board(27) :Board(27) = Board(26) :Board(26) = Board(25) 
        Board(25) = Board(24) :Board(24) = Board(23) :Board(23) = Board(22) :Board(22) = Board(21) : Board(21) = a

      End If 

      
    
     Delay 60

End Function


Function AddColumns()
     Local a = 0
      PlaySound Sound1
     For a = 0 To 9
       n1 = Board(1+a)
       n2 = Board(11+a)
       n3 = Board(21+a)
        b = n1+n2+n3
        If b = Number1 And b> 0 Then 
           Board(1+a) = 0
           Board(11+a) = 0
           Board(21+a) = 0
                Cls 
              BuildBoard()
              

              displaypieces
                VWait
                Flip
                Delay 1000


           Number1 = Rand(6,25)
            Reset()
            scan 
           Score = Score + b
           PlaySound Sound2
           
        End If
        
     Next
 
End Function

Function Scan()
    Local a1, a2, a3
       ; check for solution
   If Number1 = 6 Then
      a1 = 2 : a2 = 2 : a3 = 2
      Board(1) = a1 : Board(12) = a2 : Board(24) = a3
   End If 
   If Number1 = 7 Then
      a1 = 2 : a2 = 2 : a3 = 3
      Board(1) = a1 : Board(12) = a2 : Board(24) = a3
   End If
   If Number1 = 8 Then
      a1 = 3 : a2 = 3 : a3 = 2
      Board(1) = a1 : Board(12) = a2 : Board(24) = a3
   End If
   If Number1 = 9 Then
      a1 = 3 : a2 = 3 : a3 = 3
      Board(1) = a1 : Board(12) = a2 : Board(24) = a3
   End If
   If Number1 = 10 Then
      a1 = 3 : a2 = 4 : a3 = 3
      Board(2) = a1 : Board(19) = a2 : Board(24) = a3
   End If
   If Number1 = 11 Then
      a1 = 5 : a2 = 3 : a3 = 3
      Board(2) = a1 : Board(19) = a2 : Board(24) = a3
   End If
   If Number1 = 12 Then
      a1 = 4 : a2 = 4 : a3 = 4
      Board(2) = a1 : Board(19) = a2 : Board(24) = a3
   End If
   If Number1 = 13 Then
     a1 = 4 : a2 = 4 : a3 = 5
      Board(2) = a1 : Board(19) = a2 : Board(24) = a3
   End If
   If Number1 = 14 Then
      a1 = 7 : a2 = 3 : a3 = 4
      Board(2) = a1 : Board(19) = a2 : Board(24) = a3
   End If
   If Number1 = 15 Then
      a1 = 4 : a2 = 4 : a3 = 7
      Board(2) = a1 : Board(19) = a2 : Board(24) = a3
   End If
   If Number1 = 16 Then
      a1 = 5 : a2 = 5 : a3 = 6
      Board(2) = a1 : Board(19) = a2 : Board(24) = a3
   End If
   If Number1 = 17 Then
      a1 = 6 : a2 = 6 : a3 = 5
      Board(5) = a1 : Board(12) = a2 : Board(24) = a3
   End If
   If Number1 = 18 Then
      a1 = 5 : a2 = 5 : a3 = 8
      Board(5) = a1 : Board(12) = a2 : Board(24) = a3
   End If
   If Number1 = 19 Then
      a1 = 8 : a2 = 7 : a3 = 4
      Board(5) = a1 : Board(12) = a2 : Board(24) = a3
   End If
   If Number1 = 20 Then
      a1 = 9 : a2 = 9 : a3 = 2
      Board(5) = a1 : Board(12) = a2 : Board(24) = a3
   End If
      Board(5) = a1 : Board(12) = a2 : Board(24) = a3
   If Number1 = 21 Then
      a1 = 8 : a2 = 9 : a3 = 4
      Board(5) = a1 : Board(12) = a2 : Board(24) = a3
   End If
   If Number1 = 22 Then
      a1 = 8 : a2 = 9 : a3 = 5
      Board(5) = a1 : Board(12) = a2 : Board(24) = a3
   End If
   If Number1 = 23 Then
      a1 = 8 : a2 = 9 : a3 = 6
      Board(5) = a1 : Board(12) = a2 : Board(24) = a3
   End If
   If Number1 = 24 Then
      a1 = 9 : a2 = 9 : a3 = 6
      Board(5) = a1 : Board(12) = a2 : Board(24) = a3
   End If
   If Number1 = 25 Then
      a1 = 9 : a2 = 9 : a3 = 7
      Board(5) = a1 : Board(12) = a2 : Board(24) = a3
   End If

End Function 

Function Reset()
 Local a 
   Number1 = Rand(6,25)
        

 For a = 1 To 30
   If  Board(a) = 0 Then Board(a) = Rand(2,9)

 Next 


End Function

Function Reset2()
 Local a 
   Number1 = Rand(6,25)
            
 For a = 1 To 30
   Board(a) = Rand(2,9)

 Next 


End Function

Function SetScore()
  Text 50,30, "                  "

  Text 50,30, "SCORE:"
  Text 100,30, Score


End Function 

Function  EndGame()
  
 If Moves < 1 Then GameOver = 1



End Function